package com.lgfischer.example;

import android.app.Activity;
import android.graphics.Color;
import android.graphics.Rect;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class NinePatchExampleActivity extends Activity {

	ViewGroup rootLayout;
	TextView textField;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		rootLayout = (ViewGroup) findViewById(R.id.root_layout);
		textField = (TextView) findViewById(R.id.text_field);

		textField.setOnClickListener(new MyClickListener(rootLayout));
	}

	class MyClickListener implements View.OnClickListener {

		ViewGroup rootLayout;
		boolean enabled = false;

		public MyClickListener(ViewGroup rootLayout) {
			this.rootLayout = rootLayout;
		}

		public void onClick(View v) {
			if (!enabled) {
				setNinePatchWithBug();
				//setCorrectNinePatch();
				//setNinePatchAlternative();;
				enabled = true;
			} else {
				rootLayout.setBackgroundColor(Color.TRANSPARENT);
				enabled = false;
			}
		}

		private void setNinePatchWithBug() {
			rootLayout.setBackgroundResource(R.drawable.nine_patch); //this is a buggy nine-patch
		}

		private void setCorrectNinePatch() {
			rootLayout.setBackgroundResource(R.drawable.nine_patch_ok); //this nine-patch works
		}

		private void setNinePatchAlternative() {
			//backup the old padding
			Rect padding = new Rect();
			padding.left = rootLayout.getLeft();
			padding.top = rootLayout.getTop();
			padding.right = rootLayout.getRight();
			padding.bottom = rootLayout.getPaddingBottom();
			
			rootLayout.setBackgroundResource(R.drawable.nine_patch); //this is a buggy nine-patch
			
			//restore the old padding
			rootLayout.setPadding(padding.left, padding.top, padding.right, padding.bottom);
		}
	}
}